
/*  A Bison parser, made from ./config.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	D_NUMBER	257
#define	D_STRING	258
#define	D_BOOL	259
#define	D_UID	260
#define	D_GID	261
#define	I_SERVER	262
#define	I_USER	263
#define	I_DIRECTORY	264
#define	I_UNPRIVUID	265
#define	I_UNPRIVGID	266
#define	I_XFERBUFFSIZE	267
#define	I_FAKECHROOT	268
#define	I_FORKCLIENTS	269
#define	I_RESET	270
#define	I_EXEC	271
#define	I_LOCALEDIR	272
#define	I_TRUSTEDCERTSDIR	273
#define	I_MAXMMAPSIZE	274
#define	I_PIDFILE	275
#define	I_ACCOUNTERSOCK	276
#define	I_PORT	277
#define	I_BIND	278
#define	I_MINPASVPORT	279
#define	I_MAXPASVPORT	280
#define	I_PASSIFINVALID	281
#define	I_ALLOWUNBOUND	282
#define	I_ALLOWFOREIGN	283
#define	I_ALLOWLOWPORTS	284
#define	I_USERALIAS	285
#define	I_SLEEPONFAIL	286
#define	I_ALLOWOUTOFRANGE	287
#define	I_MAXLOGINATTEMPTS	288
#define	I_PAMSERVICE	289
#define	I_RANGE	290
#define	I_DEFAULTHARDLINK	291
#define	I_ACCEPTTLS	292
#define	I_TLSVERIFYCLIENT	293
#define	I_TLSAUTOLOGIN	294
#define	I_TLSNONEWUSER	295
#define	I_DIRECTORYMSGFILE	296
#define	I_MAXCONNECTS	297
#define	I_SQLCONNECT	298
#define	I_SQLPASSWORD	299
#define	I_SQLTLSCONNECT	300
#define	I_SQLUSERQUERY	301
#define	I_SQLDIRQUERY	302
#define	I_SQLCONNECTQUERY	303
#define	I_LOGINFAILEDMSG	304
#define	I_USERINVALIDMSG	305
#define	I_PASSREQUESTMSG	306
#define	I_ANONPASSMSG	307
#define	I_WELCOMEMSG	308
#define	I_ANONYMOUS	309
#define	I_HOME	310
#define	I_CHROOT	311
#define	I_ALIAS	312
#define	I_PASSWORDNEEDED	313
#define	I_PASSWORD	314
#define	I_UID	315
#define	I_GID	316
#define	I_ALLOWLOGIN	317
#define	I_MAXIDLE	318
#define	I_ALLOWSECLOGIN	319
#define	I_MAXLOGINS	320
#define	I_EXTERNLOGIN	321
#define	I_EXTERNACCESS	322
#define	I_ADMIN	323
#define	I_LIST	324
#define	I_MSG	325
#define	I_ABORT	326
#define	I_DISCONNECT	327
#define	I_RELOAD	328
#define	I_ALLOW	329
#define	I_DENY	330
#define	I_HIDDEN	331
#define	I_FAKEUSER	332
#define	I_FAKEGROUP	333
#define	I_REQUIRE	334
#define	I_MASK	335
#define	I_SEARCH	336
#define	I_READFILE	337
#define	I_LISTING	338
#define	I_CREATEFILE	339
#define	I_CREATEDIR	340
#define	I_APPEND	341
#define	I_OVERWRITE	342
#define	I_FAKEFILEMODE	343
#define	I_FAKEDIRMODE	344
#define	I_HARDLINK	345
#define	I_DELETE	346
#define	I_RENAME	347
#define	I_READING	348
#define	I_WRITING	349
#define	I_STORING	350
#define	I_ALL	351
#define	I_ENCRYPTED	352
#define	I_SIGNED	353
#define	I_ETAG	354

#line 14 "./config.y"


#include "system.h"

#include "confparse.h"

#include "server.h"
#include "user.h"
#include "utf8fs/file.h"
#include "utf8fs/memory.h"

static struct stack
{
  void *item;
  struct stack *next;
} *servstack, *userstack, *dirstack, *servtop, *usertop, *dirtop;

static server_t *currserv;
static user_t *curruser;
static access_t *currdir;

int confExpectingToken;

extern int unprivUid, unprivGid;
extern int xferBufferSize, fakeChroot, forkConnections;
extern long long maxMmapSize;
extern const char *localeDir, *pidFile, *accPath;
extern char *sslCertsPath;


#line 45 "./config.y"
typedef union
{
  long long num;
  char str[1000];
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		341
#define	YYFLAG		-32768
#define	YYNTBASE	105

#define YYTRANSLATE(x) ((unsigned)(x) <= 354 ? yytranslate[x] : 187)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,   104,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,   101,   102,
     2,   103,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     5,     7,     9,    11,    14,    16,    17,
    21,    22,    26,    29,    32,    35,    36,    40,    41,    45,
    48,    49,    53,    54,    58,    62,    63,    69,    73,    74,
    77,    79,    82,    84,    86,    89,    90,    94,    95,    99,
   102,   105,   108,   111,   114,   117,   120,   121,   125,   128,
   131,   134,   135,   139,   140,   144,   145,   149,   150,   154,
   155,   159,   162,   163,   164,   171,   174,   177,   180,   181,
   182,   189,   192,   195,   196,   200,   203,   204,   208,   209,
   210,   211,   212,   225,   226,   230,   231,   232,   239,   240,
   244,   245,   249,   250,   254,   257,   260,   262,   266,   268,
   270,   272,   274,   276,   278,   280,   282,   284,   286,   288,
   290,   294,   295,   301,   305,   306,   309,   311,   314,   316,
   319,   320,   324,   325,   329,   330,   334,   337,   338,   342,
   343,   347,   348,   352,   355,   358,   361,   364,   367,   368,
   372,   373,   377,   380,   381,   385,   386,   390,   393,   396,
   399,   401,   405,   407,   409,   411,   413,   415,   417,   419,
   423,   425,   427,   429,   431,   433,   435,   437,   439,   441,
   445,   446,   452,   456,   457,   460,   462,   465,   468,   471,
   474,   477,   478,   482,   483,   487,   488,   492,   493,   497,
   500,   501,   505,   506,   510,   513,   515,   519,   521,   523,
   525,   527,   529,   531,   535,   537,   539,   541,   543,   545,
   547,   549,   551,   553,   555,   557,   559,   561,   563
};

static const short yyrhs[] = {    -1,
   105,   108,     0,     0,   101,     0,     5,     0,     3,     0,
   109,   106,     0,   116,     0,     0,    11,   110,     6,     0,
     0,    12,   111,     7,     0,    13,     3,     0,    14,   107,
     0,    15,   107,     0,     0,    18,   112,     4,     0,     0,
    19,   113,     4,     0,    20,     3,     0,     0,    21,   114,
     4,     0,     0,    22,   115,     4,     0,   117,   120,   119,
     0,     0,   102,     8,   118,     4,   103,     0,   100,     8,
   103,     0,     0,   120,   121,     0,   116,     0,   122,   106,
     0,   149,     0,   170,     0,    23,     3,     0,     0,    24,
   123,     4,     0,     0,    36,   124,     4,     0,    25,     3,
     0,    26,     3,     0,    27,   107,     0,    28,   107,     0,
    29,   107,     0,    33,   107,     0,    30,   107,     0,     0,
    57,   125,     4,     0,    59,   107,     0,    63,   107,     0,
    65,   107,     0,     0,    50,   126,     4,     0,     0,    51,
   127,     4,     0,     0,    52,   128,     4,     0,     0,    53,
   129,     4,     0,     0,    54,   130,     4,     0,    64,     3,
     0,     0,     0,    38,   131,     4,   104,   132,     4,     0,
    39,     5,     0,    40,     5,     0,    41,     5,     0,     0,
     0,    31,   133,     4,   104,   134,     4,     0,    32,     3,
     0,    34,     3,     0,     0,    35,   135,     4,     0,    37,
   107,     0,     0,    42,   136,     4,     0,     0,     0,     0,
     0,    44,   137,     4,   104,   138,     4,   104,   139,     4,
   104,   140,     4,     0,     0,    45,   141,     4,     0,     0,
     0,    46,   142,     4,   104,   143,     4,     0,     0,    47,
   144,     4,     0,     0,    48,   145,     4,     0,     0,    49,
   146,     4,     0,    43,     3,     0,    16,   147,     0,   148,
     0,   147,   104,   148,     0,    23,     0,    24,     0,    50,
     0,    51,     0,    52,     0,    53,     0,    42,     0,    54,
     0,    36,     0,    47,     0,    48,     0,    49,     0,   150,
   153,   152,     0,     0,   102,     9,   151,     4,   103,     0,
   100,     9,   103,     0,     0,   153,   154,     0,   149,     0,
   155,   106,     0,   170,     0,    55,   107,     0,     0,    58,
   156,     4,     0,     0,    56,   157,     4,     0,     0,    57,
   158,     4,     0,    59,   107,     0,     0,    60,   159,     4,
     0,     0,    61,   160,     6,     0,     0,    62,   161,     7,
     0,    63,   107,     0,    65,   107,     0,    29,   107,     0,
    33,   107,     0,    64,     3,     0,     0,    67,   162,     4,
     0,     0,    68,   163,     4,     0,    37,   107,     0,     0,
    42,   164,     4,     0,     0,    48,   165,     4,     0,    69,
   166,     0,    66,     3,     0,    16,   168,     0,   167,     0,
   166,   104,   167,     0,    70,     0,    71,     0,    72,     0,
    73,     0,    74,     0,    97,     0,   169,     0,   168,   104,
   169,     0,    61,     0,    62,     0,    56,     0,    60,     0,
    67,     0,    68,     0,    42,     0,    48,     0,    69,     0,
   171,   174,   173,     0,     0,   102,    10,   172,     4,   103,
     0,   100,    10,   103,     0,     0,   174,   175,     0,   170,
     0,   176,   106,     0,    75,   185,     0,    76,   185,     0,
    80,   185,     0,    77,   107,     0,     0,    78,   177,     4,
     0,     0,    79,   178,     4,     0,     0,    89,   179,     4,
     0,     0,    90,   180,     4,     0,    91,   107,     0,     0,
    42,   181,     4,     0,     0,    81,   182,     4,     0,    16,
   183,     0,   184,     0,   183,   104,   184,     0,    78,     0,
    79,     0,    89,     0,    90,     0,    42,     0,   186,     0,
   185,   104,   186,     0,    82,     0,    83,     0,    84,     0,
    85,     0,    86,     0,    87,     0,    88,     0,    92,     0,
    93,     0,    98,     0,    99,     0,    94,     0,    95,     0,
    96,     0,    97,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    93,    94,    97,    98,   101,   103,   107,   108,   111,   114,
   117,   120,   123,   132,   136,   140,   143,   157,   160,   164,
   168,   171,   174,   177,   182,   185,   187,   216,   223,   224,
   227,   228,   229,   230,   233,   237,   240,   243,   246,   347,
   357,   367,   371,   375,   379,   383,   387,   390,   395,   399,
   403,   407,   410,   415,   418,   423,   426,   431,   434,   439,
   442,   446,   450,   452,   455,   513,   520,   524,   528,   530,
   533,   536,   540,   544,   547,   556,   560,   563,   567,   570,
   573,   576,   579,   608,   611,   617,   620,   623,   635,   638,
   644,   647,   653,   656,   662,   666,   669,   670,   673,   680,
   687,   693,   699,   705,   711,   716,   721,   727,   734,   741,
   750,   753,   755,   814,   840,   841,   844,   845,   846,   849,
   859,   862,   865,   868,   873,   876,   881,   885,   888,   895,
   898,   902,   905,   909,   913,   917,   921,   925,   929,   932,
   936,   939,   943,   947,   950,   954,   957,   963,   967,   971,
   974,   978,   984,   988,   992,   996,  1000,  1004,  1010,  1011,
  1014,  1018,  1022,  1029,  1033,  1038,  1043,  1048,  1055,  1061,
  1064,  1066,  1085,  1169,  1170,  1173,  1174,  1177,  1183,  1189,
  1197,  1201,  1204,  1208,  1211,  1215,  1218,  1222,  1225,  1229,
  1233,  1236,  1240,  1243,  1252,  1255,  1256,  1259,  1265,  1271,
  1277,  1283,  1290,  1294,  1300,  1304,  1308,  1312,  1316,  1320,
  1324,  1328,  1332,  1336,  1340,  1344,  1348,  1353,  1357
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","D_NUMBER",
"D_STRING","D_BOOL","D_UID","D_GID","I_SERVER","I_USER","I_DIRECTORY","I_UNPRIVUID",
"I_UNPRIVGID","I_XFERBUFFSIZE","I_FAKECHROOT","I_FORKCLIENTS","I_RESET","I_EXEC",
"I_LOCALEDIR","I_TRUSTEDCERTSDIR","I_MAXMMAPSIZE","I_PIDFILE","I_ACCOUNTERSOCK",
"I_PORT","I_BIND","I_MINPASVPORT","I_MAXPASVPORT","I_PASSIFINVALID","I_ALLOWUNBOUND",
"I_ALLOWFOREIGN","I_ALLOWLOWPORTS","I_USERALIAS","I_SLEEPONFAIL","I_ALLOWOUTOFRANGE",
"I_MAXLOGINATTEMPTS","I_PAMSERVICE","I_RANGE","I_DEFAULTHARDLINK","I_ACCEPTTLS",
"I_TLSVERIFYCLIENT","I_TLSAUTOLOGIN","I_TLSNONEWUSER","I_DIRECTORYMSGFILE","I_MAXCONNECTS",
"I_SQLCONNECT","I_SQLPASSWORD","I_SQLTLSCONNECT","I_SQLUSERQUERY","I_SQLDIRQUERY",
"I_SQLCONNECTQUERY","I_LOGINFAILEDMSG","I_USERINVALIDMSG","I_PASSREQUESTMSG",
"I_ANONPASSMSG","I_WELCOMEMSG","I_ANONYMOUS","I_HOME","I_CHROOT","I_ALIAS","I_PASSWORDNEEDED",
"I_PASSWORD","I_UID","I_GID","I_ALLOWLOGIN","I_MAXIDLE","I_ALLOWSECLOGIN","I_MAXLOGINS",
"I_EXTERNLOGIN","I_EXTERNACCESS","I_ADMIN","I_LIST","I_MSG","I_ABORT","I_DISCONNECT",
"I_RELOAD","I_ALLOW","I_DENY","I_HIDDEN","I_FAKEUSER","I_FAKEGROUP","I_REQUIRE",
"I_MASK","I_SEARCH","I_READFILE","I_LISTING","I_CREATEFILE","I_CREATEDIR","I_APPEND",
"I_OVERWRITE","I_FAKEFILEMODE","I_FAKEDIRMODE","I_HARDLINK","I_DELETE","I_RENAME",
"I_READING","I_WRITING","I_STORING","I_ALL","I_ENCRYPTED","I_SIGNED","I_ETAG",
"';'","'<'","'>'","','","input","semicolon","bool","topst","topopt","@1","@2",
"@3","@4","@5","@6","server","servstart","@7","servend","servdata","servst",
"servopt","@8","@9","@10","@11","@12","@13","@14","@15","@16","@17","@18","@19",
"@20","@21","@22","@23","@24","@25","@26","@27","@28","@29","@30","@31","srvrstlist",
"srvrstitem","user","userstart","@32","userend","userdata","userst","useropt",
"@33","@34","@35","@36","@37","@38","@39","@40","@41","@42","adminlist","adminitem",
"usrrstlist","usrrstitem","directory","dirstart","@43","dirend","dirdata","dirst",
"diropt","@44","@45","@46","@47","@48","@49","dirrstlist","dirrstitem","accesslist",
"accessitem", NULL
};
#endif

static const short yyr1[] = {     0,
   105,   105,   106,   106,   107,   107,   108,   108,   110,   109,
   111,   109,   109,   109,   109,   112,   109,   113,   109,   109,
   114,   109,   115,   109,   116,   118,   117,   119,   120,   120,
   121,   121,   121,   121,   122,   123,   122,   124,   122,   122,
   122,   122,   122,   122,   122,   122,   125,   122,   122,   122,
   122,   126,   122,   127,   122,   128,   122,   129,   122,   130,
   122,   122,   131,   132,   122,   122,   122,   122,   133,   134,
   122,   122,   122,   135,   122,   122,   136,   122,   137,   138,
   139,   140,   122,   141,   122,   142,   143,   122,   144,   122,
   145,   122,   146,   122,   122,   122,   147,   147,   148,   148,
   148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
   149,   151,   150,   152,   153,   153,   154,   154,   154,   155,
   156,   155,   157,   155,   158,   155,   155,   159,   155,   160,
   155,   161,   155,   155,   155,   155,   155,   155,   162,   155,
   163,   155,   155,   164,   155,   165,   155,   155,   155,   155,
   166,   166,   167,   167,   167,   167,   167,   167,   168,   168,
   169,   169,   169,   169,   169,   169,   169,   169,   169,   170,
   172,   171,   173,   174,   174,   175,   175,   176,   176,   176,
   176,   177,   176,   178,   176,   179,   176,   180,   176,   176,
   181,   176,   182,   176,   176,   183,   183,   184,   184,   184,
   184,   184,   185,   185,   186,   186,   186,   186,   186,   186,
   186,   186,   186,   186,   186,   186,   186,   186,   186
};

static const short yyr2[] = {     0,
     0,     2,     0,     1,     1,     1,     2,     1,     0,     3,
     0,     3,     2,     2,     2,     0,     3,     0,     3,     2,
     0,     3,     0,     3,     3,     0,     5,     3,     0,     2,
     1,     2,     1,     1,     2,     0,     3,     0,     3,     2,
     2,     2,     2,     2,     2,     2,     0,     3,     2,     2,
     2,     0,     3,     0,     3,     0,     3,     0,     3,     0,
     3,     2,     0,     0,     6,     2,     2,     2,     0,     0,
     6,     2,     2,     0,     3,     2,     0,     3,     0,     0,
     0,     0,    12,     0,     3,     0,     0,     6,     0,     3,
     0,     3,     0,     3,     2,     2,     1,     3,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     3,     0,     5,     3,     0,     2,     1,     2,     1,     2,
     0,     3,     0,     3,     0,     3,     2,     0,     3,     0,
     3,     0,     3,     2,     2,     2,     2,     2,     0,     3,
     0,     3,     2,     0,     3,     0,     3,     2,     2,     2,
     1,     3,     1,     1,     1,     1,     1,     1,     1,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
     0,     5,     3,     0,     2,     1,     2,     2,     2,     2,
     2,     0,     3,     0,     3,     0,     3,     0,     3,     2,
     0,     3,     0,     3,     2,     1,     3,     1,     1,     1,
     1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1
};

static const short yydefact[] = {     1,
     0,     9,    11,     0,     0,     0,    16,    18,     0,    21,
    23,     0,     2,     3,     8,    29,     0,     0,    13,     6,
     5,    14,    15,     0,     0,    20,     0,     0,    26,     4,
     7,     0,    10,    12,    17,    19,    22,    24,     0,     0,
     0,    36,     0,     0,     0,     0,     0,     0,    69,     0,
     0,     0,    74,    38,     0,    63,     0,     0,     0,    77,
     0,    79,    84,    86,    89,    91,    93,    52,    54,    56,
    58,    60,    47,     0,     0,     0,     0,     0,     0,    31,
    25,    30,     3,    33,   115,    34,   174,     0,    99,   100,
   107,   105,   108,   109,   110,   101,   102,   103,   104,   106,
    96,    97,    35,     0,    40,    41,    42,    43,    44,    46,
     0,    72,    45,    73,     0,     0,    76,     0,    66,    67,
    68,     0,    95,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    49,    50,    62,    51,     0,
   112,   171,    32,     0,     0,    27,     0,    37,     0,    75,
    39,     0,    78,     0,    85,     0,    90,    92,    94,    53,
    55,    57,    59,    61,    48,    28,     0,     0,     0,     0,
     0,     0,   144,   146,     0,   123,   125,   121,     0,   128,
   130,   132,     0,     0,     0,     0,   139,   141,     0,     0,
     0,   117,   111,   116,     3,   119,     0,   191,     0,     0,
     0,   182,   184,     0,   193,   186,   188,     0,     0,     0,
   176,   170,   175,     3,    98,    70,    64,    80,    87,     0,
     0,   167,   168,   163,   164,   161,   162,   165,   166,   169,
   150,   159,   136,   137,   143,     0,     0,   120,     0,     0,
     0,   127,     0,     0,     0,   134,   138,   135,   149,     0,
     0,   153,   154,   155,   156,   157,   158,   148,   151,     0,
   118,   202,   198,   199,   200,   201,   195,   196,     0,   205,
   206,   207,   208,   209,   210,   211,   212,   213,   216,   217,
   218,   219,   214,   215,   178,   203,   179,   181,     0,     0,
   180,     0,     0,     0,   190,     0,   177,     0,     0,     0,
     0,   113,   172,     0,   145,   147,   124,   126,   122,   129,
   131,   133,   140,   142,     0,   114,     0,   192,     0,   183,
   185,   194,   187,   189,   173,    71,    65,     0,    88,   160,
   152,   197,   204,    81,     0,     0,    82,     0,    83,     0,
     0
};

static const short yydefgoto[] = {     1,
    31,    22,    13,    14,    17,    18,    24,    25,    27,    28,
    15,    16,    39,    81,    32,    82,    83,   104,   116,   135,
   130,   131,   132,   133,   134,   118,   299,   111,   298,   115,
   122,   124,   300,   335,   338,   125,   126,   301,   127,   128,
   129,   101,   102,    84,    85,   167,   193,   144,   194,   195,
   241,   239,   240,   243,   244,   245,   250,   251,   236,   237,
   258,   259,   231,   232,    86,    87,   168,   212,   145,   213,
   214,   289,   290,   293,   294,   269,   292,   267,   268,   285,
   286
};

static const short yypact[] = {-32768,
     2,-32768,-32768,     0,    43,    43,-32768,-32768,    33,-32768,
-32768,    26,-32768,   -64,-32768,-32768,    29,    36,-32768,-32768,
-32768,-32768,-32768,    46,    66,-32768,    68,    71,-32768,-32768,
-32768,   180,-32768,-32768,-32768,-32768,-32768,-32768,    72,    92,
    76,-32768,    78,    79,    43,    43,    43,    43,-32768,    80,
    43,    81,-32768,-32768,    43,-32768,    82,    84,    85,-32768,
    83,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    43,    43,    88,    43,    77,     1,-32768,
-32768,-32768,   -64,-32768,-32768,-32768,-32768,    -8,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    -7,-32768,-32768,    98,-32768,-32768,-32768,-32768,-32768,-32768,
    99,-32768,-32768,-32768,   101,   110,-32768,   113,-32768,-32768,
-32768,   114,-32768,   115,   119,   120,   121,   122,   123,   125,
   126,   131,   132,   133,   134,-32768,-32768,-32768,-32768,    44,
-32768,-32768,-32768,    -4,    31,-32768,    92,-32768,    45,-32768,
-32768,    47,-32768,    48,-32768,    49,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   144,   146,    32,    43,
    43,    43,-32768,-32768,    43,-32768,-32768,-32768,    43,-32768,
-32768,-32768,    43,   151,    43,   152,-32768,-32768,   -66,   147,
     9,-32768,-32768,-32768,   -64,-32768,   -12,-32768,   164,   164,
    43,-32768,-32768,   164,-32768,-32768,-32768,    43,   148,   149,
-32768,-32768,-32768,   -64,-32768,-32768,-32768,-32768,-32768,    54,
    57,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    58,-32768,-32768,-32768,-32768,   157,   159,-32768,   163,   166,
   167,-32768,   168,   162,   169,-32768,-32768,-32768,-32768,   170,
   171,-32768,-32768,-32768,-32768,-32768,-32768,    74,-32768,    86,
-32768,-32768,-32768,-32768,-32768,-32768,    87,-32768,   176,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    89,-32768,    89,-32768,   177,   178,
    89,   179,   181,   182,-32768,    91,-32768,   183,   184,   186,
   188,-32768,-32768,    32,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   -66,-32768,   -12,-32768,   164,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    93,-32768,-32768,
-32768,-32768,-32768,-32768,   194,    95,-32768,   196,-32768,   201,
-32768
};

static const short yypgoto[] = {-32768,
   -82,    -6,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   203,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    37,    94,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -79,-32768,   -63,  -118,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -77,  -172,
   -65
};


#define	YYLAST		282


static const short yytable[] = {    23,
   143,   340,    19,   252,   253,   254,   255,   256,    29,   141,
   142,   169,     2,     3,     4,     5,     6,   141,   142,     7,
     8,     9,    10,    11,   170,   196,   211,   287,   171,   262,
   257,   291,   172,    29,    33,    26,    30,   173,   107,   108,
   109,   110,    34,   174,   113,    20,   197,    21,   117,    35,
   175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
   185,   186,   187,   188,   189,   263,   264,   136,   137,    36,
   139,    37,   198,   222,    38,    88,   265,   266,   103,   223,
   105,   106,   112,   114,   140,   123,   119,   224,   120,   121,
   138,   225,   226,   227,   146,   190,   147,   191,   228,   229,
   230,   148,   149,    12,   150,   199,   200,   201,   202,   203,
   204,   205,   261,   151,    89,    90,   152,   153,   154,   206,
   207,   208,   155,   156,   157,   158,   159,    91,   160,   161,
   209,   297,   210,    92,   162,   163,   164,   165,    93,    94,
    95,    96,    97,    98,    99,   100,   166,   220,   216,   221,
   217,   218,   219,   247,   249,   260,   302,   296,   142,   303,
   305,   304,   306,   233,   234,   235,   307,   311,   238,   308,
   309,   310,   242,   313,   314,   312,   246,   315,   248,   318,
   320,   321,   322,   215,   323,   324,   326,   327,   316,   328,
   317,   329,   319,   325,   288,    40,   334,   336,   337,   339,
   341,   295,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    80,   331,    73,   192,    74,   332,
   330,     0,    75,    76,    77,   270,   271,   272,   273,   274,
   275,   276,     0,   333,     0,   277,   278,   279,   280,   281,
   282,   283,   284,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
     0,    79
};

static const short yycheck[] = {     6,
    83,     0,     3,    70,    71,    72,    73,    74,     8,     9,
    10,    16,    11,    12,    13,    14,    15,     9,    10,    18,
    19,    20,    21,    22,    29,   144,   145,   200,    33,    42,
    97,   204,    37,     8,     6,     3,   101,    42,    45,    46,
    47,    48,     7,    48,    51,     3,    16,     5,    55,     4,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    78,    79,    74,    75,     4,
    77,     4,    42,    42,     4,     4,    89,    90,     3,    48,
     3,     3,     3,     3,     8,     3,     5,    56,     5,     5,
     3,    60,    61,    62,   103,   100,   104,   102,    67,    68,
    69,     4,     4,   102,     4,    75,    76,    77,    78,    79,
    80,    81,   195,     4,    23,    24,     4,     4,     4,    89,
    90,    91,     4,     4,     4,     4,     4,    36,     4,     4,
   100,   214,   102,    42,     4,     4,     4,     4,    47,    48,
    49,    50,    51,    52,    53,    54,   103,     4,   104,     4,
   104,   104,   104,     3,     3,     9,   103,    10,    10,   103,
     4,   104,     4,   170,   171,   172,     4,     6,   175,     4,
     4,     4,   179,     4,     4,     7,   183,   104,   185,     4,
     4,     4,     4,   147,     4,     4,     4,     4,   103,     4,
   104,     4,   104,   103,   201,    16,   104,     4,   104,     4,
     0,   208,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    32,   315,    57,   144,    59,   317,
   304,    -1,    63,    64,    65,    82,    83,    84,    85,    86,
    87,    88,    -1,   319,    -1,    92,    93,    94,    95,    96,
    97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
    -1,   102
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 5:
#line 102 "./config.y"
{ yyval.num = yyvsp[0].num; ;
    break;}
case 6:
#line 104 "./config.y"
{ yyval.num = yyvsp[0].num; ;
    break;}
case 9:
#line 112 "./config.y"
{ confExpectingToken = D_UID; ;
    break;}
case 10:
#line 114 "./config.y"
{
		  unprivUid = yyvsp[0].num;
		;
    break;}
case 11:
#line 118 "./config.y"
{ confExpectingToken = D_GID; ;
    break;}
case 12:
#line 120 "./config.y"
{
		  unprivGid = yyvsp[0].num;
		;
    break;}
case 13:
#line 124 "./config.y"
{
		  if(yyvsp[0].num <= 0)
		  {
		    syslog (LOG_ERR, "XferBuffSize must be positive.");
		    YYABORT;
		  }
		  xferBufferSize = yyvsp[0].num;
		;
    break;}
case 14:
#line 133 "./config.y"
{
		  fakeChroot = yyvsp[0].num;
		;
    break;}
case 15:
#line 137 "./config.y"
{
		  forkConnections = yyvsp[0].num;
		;
    break;}
case 16:
#line 141 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 17:
#line 143 "./config.y"
{
		  if (yyvsp[0].str[strlen (yyvsp[0].str) - 1] != '/')
		  {
		    char *tmp = talloc (strlen (yyvsp[0].str) + 2);
		    if (tmp)
		    {
		      strcpy (tmp, yyvsp[0].str);
		      strcat (tmp, "/");
		      localeDir = pstring (tmp, NULL);
		    }
		  }
		  else
		    localeDir = pstring (yyvsp[0].str, NULL);
		;
    break;}
case 18:
#line 158 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 19:
#line 160 "./config.y"
{
		  pfree (sslCertsPath, NULL);
		  sslCertsPath = pstring (yyvsp[0].str, NULL);
		;
    break;}
case 20:
#line 165 "./config.y"
{
		  maxMmapSize = yyvsp[0].num;
		;
    break;}
case 21:
#line 169 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 22:
#line 171 "./config.y"
{
		  pidFile = pstring (yyvsp[0].str, NULL);
		;
    break;}
case 23:
#line 175 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 24:
#line 177 "./config.y"
{
		  accPath = pstring (yyvsp[0].str, NULL);
		;
    break;}
case 26:
#line 186 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 27:
#line 188 "./config.y"
{
		  char *np;
		  
		  for (np = yyvsp[-1].str; *np; np++)
		  {
		    if (isspace (*np & 0xFF))
		    {
		      syslog (LOG_ERR, "A server name can't contain whitespace (%s).", yyvsp[-1].str);
		      YYABORT;
		    }
		  }
		  if (find_named_server (yyvsp[-1].str, 0, NULL, NULL))
		  {
		    syslog (LOG_ERR, "Two servers can not have the same name (%s).", yyvsp[-1].str);
		    YYABORT;
		  }
		  currserv = new_server(yyvsp[-1].str, currserv);
		  servtop = talloc (sizeof (*servtop));
		  
		  if(!currserv || !servtop)
		    YYABORT;
		  
		  servtop->item = currserv;
		  servtop->next = servstack;
		  servstack = servtop;
		;
    break;}
case 28:
#line 217 "./config.y"
{
		  servstack = servstack->next;
		  currserv = servstack? servstack->item : NULL;
		;
    break;}
case 35:
#line 234 "./config.y"
{
		  add_server_port(currserv, yyvsp[0].num);
		;
    break;}
case 36:
#line 238 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 37:
#line 240 "./config.y"
{
		  add_server_binding(currserv, yyvsp[0].str);
		;
    break;}
case 38:
#line 244 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 39:
#line 246 "./config.y"
{
		  char *m = strchr (yyvsp[0].str, '/'), *ep;
		  struct addrinfo hints = { AI_NUMERICHOST }, *res, *curr;
		  int err, i, j;
		  struct sockaddr_in m4;
		  struct sockaddr_in6 m6;
		  
		  if (m)
		  {
		    *m++ = 0;
		    if (!*m)
		    {
		      *--m = '/';
		      syslog (LOG_ERR, "%s: Mask missing.", yyvsp[0].str);
		      YYABORT;
		    }
		  }
		  
		  err = getaddrinfo (yyvsp[0].str, NULL, &hints, &res);
		  if (err || !res)
		  {
		    syslog (LOG_ERR, "Failed to lookup %s: %s", yyvsp[0].str,
			  gai_strerror (err));
		    YYABORT;
		  }
		  
		  m4.sin_family = AF_INET;
		  m6.sin6_family = AF_INET6;
		  for (curr = res; curr; curr = curr->ai_next)
		  {
		    switch (curr->ai_family)
		    {
		    case PF_INET:
		      if (m)
		      {
#ifdef HAVE_INET_ATON
			if (!inet_aton (m, &m4.sin_addr))
#else
			m4.sin_addr.s_addr = inet_addr (m);
			if (m4.sin_addr.s_addr == -1)
#endif
			{
			  syslog (LOG_ERR, "%s/%s: Invalid mask.", yyvsp[0].str, m);
			  YYABORT;
			}
			if (!(*(char*)&m4.sin_addr & 0x80))
			{
			  i = ntohl (m4.sin_addr.s_addr);
			  if (i > 32)
			  {
			    syslog (LOG_ERR, "%s/%s: Mask is bigger than "
				  "address length.", yyvsp[0].str, m);
			    YYABORT;
			  }
			  memset (&m4.sin_addr, 0xff, i / 8);
			  if (i < 32)
			    memset ((char*)&m4.sin_addr + i / 8 + 1, 0, 4 -
				  i / 8);
			  for (j = 0x80; i & 0x7; i--, j >>= 1)
			    ((char*)&m4.sin_addr)[i / 8 + 1] |= j;
			}
		      }
		      else
			memset (&m4.sin_addr, 0xFF, 4);
		      add_server_range (currserv, curr->ai_addr,
			    (struct sockaddr*)&m4);
		      break;
		    case PF_INET6:
		      if (m)
		      {
			i = strtoul (m, &ep, 0);
			if (*ep)
			{
			  syslog (LOG_ERR, "%s/%s: Invalid mask.", yyvsp[0].str, m);
			  YYABORT;
			}
			if (i > 128)
			{
			  syslog (LOG_ERR, "%s/%s: Mask is bigger than "
				"address length.", yyvsp[0].str, m);
			  YYABORT;
			}
			memset (&m6.sin6_addr, 0xff, i / 8);
			if (i < 128)
			  memset ((char*)&m6.sin6_addr + i / 8 + 1, 0, 16 -
				i / 8);
			for (j = 0x80; i & 0x7; i--, j >>= 1)
			  ((char*)&m6.sin6_addr)[i / 8 + 1] |= j;
		      }
		      else
			memset (&m6.sin6_addr, 0xFF, 16);
		      add_server_range (currserv, curr->ai_addr,
			    (struct sockaddr*)&m6);
		      break;
		    default:
		      // Just ignore...
		      break;
		    }
		  }
		  freeaddrinfo (res);
		;
    break;}
case 40:
#line 348 "./config.y"
{
		  if(yyvsp[0].num < 0)
		    yyvsp[0].num = 0;
		  if(yyvsp[0].num > 65535)
		    yyvsp[0].num = 65535;
		  currserv->minPasvPort = yyvsp[0].num;
		  if(currserv->maxPasvPort < currserv->minPasvPort)
		    currserv->maxPasvPort = currserv->minPasvPort;
		;
    break;}
case 41:
#line 358 "./config.y"
{
		  if(yyvsp[0].num < 0)
		    yyvsp[0].num = 0;
		  if(yyvsp[0].num > 65535)
		    yyvsp[0].num = 65535;
		  currserv->maxPasvPort = yyvsp[0].num;
		  if(currserv->minPasvPort > currserv->maxPasvPort)
		    currserv->minPasvPort = currserv->maxPasvPort;
		;
    break;}
case 42:
#line 368 "./config.y"
{
		  currserv->passIfInvalid = (yyvsp[0].num != 0);
		;
    break;}
case 43:
#line 372 "./config.y"
{
		  currserv->allowUnbound = (yyvsp[0].num != 0);
		;
    break;}
case 44:
#line 376 "./config.y"
{
		  currserv->allowForeign = (yyvsp[0].num != 0);
		;
    break;}
case 45:
#line 380 "./config.y"
{
		  currserv->allowOutOfRange = (yyvsp[0].num != 0);
		;
    break;}
case 46:
#line 384 "./config.y"
{
		  currserv->allowLowPorts = (yyvsp[0].num != 0);
		;
    break;}
case 47:
#line 388 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 48:
#line 390 "./config.y"
{
		  if(currserv->chroot)
		    pfree(currserv->chroot, currserv);
		  currserv->chroot = pstring(yyvsp[0].str, currserv);
		;
    break;}
case 49:
#line 396 "./config.y"
{
		  currserv->passwordNeeded = (yyvsp[0].num != 0);
		;
    break;}
case 50:
#line 400 "./config.y"
{
		  currserv->allowLogin = (yyvsp[0].num != 0);
		;
    break;}
case 51:
#line 404 "./config.y"
{
		  currserv->allowSecLogin = (yyvsp[0].num != 0);
		;
    break;}
case 52:
#line 408 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 53:
#line 410 "./config.y"
{
		  if(currserv->loginFailedMsg)
		    pfree(currserv->loginFailedMsg, currserv);
		  currserv->loginFailedMsg = pstring(yyvsp[0].str, currserv);
		;
    break;}
case 54:
#line 416 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 55:
#line 418 "./config.y"
{
		  if(currserv->userInvalidMsg)
		    pfree(currserv->userInvalidMsg, currserv);
		  currserv->userInvalidMsg = pstring(yyvsp[0].str, currserv);
		;
    break;}
case 56:
#line 424 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 57:
#line 426 "./config.y"
{
		  if(currserv->passRequestMsg)
		    pfree(currserv->passRequestMsg, currserv);
		  currserv->passRequestMsg = pstring(yyvsp[0].str, currserv);
		;
    break;}
case 58:
#line 432 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 59:
#line 434 "./config.y"
{
		  if(currserv->anonPassMsg)
		    pfree(currserv->anonPassMsg, currserv);
		  currserv->anonPassMsg = pstring(yyvsp[0].str, currserv);
		;
    break;}
case 60:
#line 440 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 61:
#line 442 "./config.y"
{
		  pfree (currserv->welcomeMsg, currserv);
		  currserv->welcomeMsg = pstring(yyvsp[0].str, currserv);
		;
    break;}
case 62:
#line 447 "./config.y"
{
		  currserv->maxIdle = yyvsp[0].num;
		;
    break;}
case 63:
#line 451 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 64:
#line 453 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 65:
#line 455 "./config.y"
{
#ifdef USE_TLS
		  if (currserv->tlsCert)
		  {
		    tls_free_cert (currserv->tlsCert);
		    currserv->tlsCert = NULL;
		  }
		  if (yyvsp[-3].str[0] != '/')
		  {
		    char *tmp = talloc (strlen (sslCertsPath) + strlen (yyvsp[-3].str) + 2);
		    
		    if (tmp)
		    {
		      strcpy (tmp, sslCertsPath);
		      strcat (tmp, "/");
		      strcat (tmp, yyvsp[-3].str);
		      currserv->tlsCert = tls_read_cert (tmp);
		    }
		  }
		  else
		    currserv->tlsCert = tls_read_cert (yyvsp[-3].str);
		  if (!currserv->tlsCert)
		  {
		    syslog (LOG_ERR, "Failed to read certificate file: %m");
		    errno = EINVAL;
		    YYABORT;
		  }
		  
		  if (currserv->tlsKey)
		  {
		    tls_free_key (currserv->tlsKey);
		    currserv->tlsKey = NULL;
		  }
		  if (yyvsp[0].str[0] != '/')
		  {
		    char *tmp = talloc (strlen (sslCertsPath) + strlen (yyvsp[0].str) + 2);
		    
		    if (tmp)
		    {
		      strcpy (tmp, sslCertsPath);
		      strcat (tmp, "/");
		      strcat (tmp, yyvsp[0].str);
		      currserv->tlsKey = tls_read_key (tmp);
		    }
		  }
		  else
		    currserv->tlsKey = tls_read_key (yyvsp[0].str);
		  if (!currserv->tlsKey)
		  {
		    syslog (LOG_ERR, "Error reading key: %m");
		    errno = EINVAL;
		    YYABORT;
		  }
#else
		  syslog (LOG_WARNING, "Warning: AcceptTLS used but TLS "
			"support is not compiled.");
#endif
		;
    break;}
case 66:
#line 514 "./config.y"
{
		  if (yyvsp[0].num)
		    currserv->tlsOptions |= tlsVerifyClient;
		  else
		    currserv->tlsOptions &= ~tlsVerifyClient;
		;
    break;}
case 67:
#line 521 "./config.y"
{
		  currserv->loginTLS = (yyvsp[0].num != 0);
		;
    break;}
case 68:
#line 525 "./config.y"
{
		  currserv->tlsNoLogout = (yyvsp[0].num != 0);
		;
    break;}
case 69:
#line 529 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 70:
#line 531 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 71:
#line 533 "./config.y"
{
		  server_add_alias (currserv, yyvsp[0].str, yyvsp[-3].str);
		;
    break;}
case 72:
#line 537 "./config.y"
{
		  currserv->sleepOnFail = yyvsp[0].num;
		;
    break;}
case 73:
#line 541 "./config.y"
{
		  currserv->maxLoginAttempts = yyvsp[0].num;
		;
    break;}
case 74:
#line 545 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 75:
#line 547 "./config.y"
{
#ifdef HAVE_LIBPAM
		  pfree (currserv->pam_service, currserv);
		  currserv->pam_service = pstring (yyvsp[0].str, currserv);
#else
		  syslog (LOG_WARNING, "Warning: PamService used but PAM "
			"support is not compiled.");
#endif
		;
    break;}
case 76:
#line 557 "./config.y"
{
		  currserv->defHardLink = yyvsp[0].num? 1 : 0;
		;
    break;}
case 77:
#line 561 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 78:
#line 563 "./config.y"
{
		  pfree (currserv->dirMsgFile, currserv);
		  currserv->dirMsgFile = pstring (yyvsp[0].str, currserv);
		;
    break;}
case 79:
#line 568 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 80:
#line 571 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 81:
#line 574 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 82:
#line 577 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 83:
#line 579 "./config.y"
{
#ifdef USE_SQL
		  currserv->sql.type = sqlINVALID;
#ifdef HAVE_MYSQL
		  if (!strcmp (yyvsp[-9].str, "mysql"))
		    currserv->sql.type = sqlMYSQL;
#endif
		  if (currserv->sql.type == sqlINVALID)
		  {
		    syslog (LOG_ERR, "Invalid sql type (%s).", yyvsp[-9].str);
		    YYABORT;
		  }
		  
		  pfree (currserv->sqlHost, currserv);
		  currserv->sqlHost = pstring (yyvsp[-6].str, currserv);
		  pfree (currserv->sqlUser, currserv);
		  currserv->sqlUser = pstring (yyvsp[-3].str, currserv);
		  pfree (currserv->sqlDB, currserv);
		  currserv->sqlDB = pstring (yyvsp[0].str, currserv);
		  pfree (currserv->sqlPass, currserv);
		  currserv->sqlPass = NULL;
		  pfree (currserv->sqlCert, currserv);
		  currserv->sqlCert = NULL;
		  pfree (currserv->sqlKey, currserv);
		  currserv->sqlKey = NULL;
#else
		  syslog (LOG_WARNING, "Warning: SQLConnect was used but SQL support is not compiled.");
#endif
		;
    break;}
case 84:
#line 609 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 85:
#line 611 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlPass, currserv);
		  currserv->sqlPass = pstring (yyvsp[0].str, currserv);
#endif
		;
    break;}
case 86:
#line 618 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 87:
#line 621 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 88:
#line 623 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlCert, currserv);
		  currserv->sqlCert = pstring (yyvsp[-3].str, currserv);
		  pfree (currserv->sqlKey, currserv);
		  currserv->sqlKey = pstring (yyvsp[0].str, currserv);
#if defined(HAVE_MYSQL) && !defined(HAVE_MYSQL_SSL_SET)
		  if (currserv->sql.type == sqlMYSQL)
		    syslog (LOG_WARNING, "Warning: SQLTLSConnect used but MySQL library lacks TLS support.");
#endif
#endif
		;
    break;}
case 89:
#line 636 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 90:
#line 638 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlUserQuery, currserv);
		  currserv->sqlUserQuery = pstring (yyvsp[0].str, currserv);
#endif
		;
    break;}
case 91:
#line 645 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 92:
#line 647 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlDirQuery, currserv);
		  currserv->sqlDirQuery = pstring (yyvsp[0].str, currserv);
#endif
		;
    break;}
case 93:
#line 654 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 94:
#line 656 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlConnectQuery, currserv);
		  currserv->sqlConnectQuery = pstring (yyvsp[0].str, currserv);
#endif
		;
    break;}
case 95:
#line 663 "./config.y"
{
		  currserv->maxConnects = yyvsp[0].num;
		;
    break;}
case 99:
#line 674 "./config.y"
{
		  if(currserv->ports)
		    pfree(currserv->ports, currserv);
		  currserv->ports = NULL;
		  currserv->numPorts = 0;
		;
    break;}
case 100:
#line 681 "./config.y"
{
		  if(currserv->bindings)
		    pfree(currserv->bindings, currserv);
		  currserv->bindings = NULL;
		  currserv->numBindings = 0;
		;
    break;}
case 101:
#line 688 "./config.y"
{
		  if(currserv->loginFailedMsg)
		    pfree(currserv->loginFailedMsg, currserv);
		  currserv->loginFailedMsg = NULL;
		;
    break;}
case 102:
#line 694 "./config.y"
{
		  if(currserv->userInvalidMsg)
		    pfree(currserv->userInvalidMsg, currserv);
		  currserv->userInvalidMsg = NULL;
		;
    break;}
case 103:
#line 700 "./config.y"
{
		  if(currserv->passRequestMsg)
		    pfree(currserv->passRequestMsg, currserv);
		  currserv->passRequestMsg = NULL;
		;
    break;}
case 104:
#line 706 "./config.y"
{
		  if(currserv->anonPassMsg)
		    pfree(currserv->anonPassMsg, currserv);
		  currserv->anonPassMsg = NULL;
		;
    break;}
case 105:
#line 712 "./config.y"
{
		  pfree (currserv->dirMsgFile, currserv);
		  currserv->dirMsgFile = NULL;
		;
    break;}
case 106:
#line 717 "./config.y"
{
		  pfree (currserv->welcomeMsg, currserv);
		  currserv->welcomeMsg = NULL;
		;
    break;}
case 107:
#line 722 "./config.y"
{
		  pfree (currserv->ranges, currserv);
		  currserv->ranges = NULL;
		  currserv->numRanges = 0;
		;
    break;}
case 108:
#line 728 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlUserQuery, currserv);
		  currserv->sqlUserQuery = NULL;
#endif
		;
    break;}
case 109:
#line 735 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlDirQuery, currserv);
		  currserv->sqlDirQuery = NULL;
#endif
		;
    break;}
case 110:
#line 742 "./config.y"
{
#ifdef USE_SQL
		  pfree (currserv->sqlConnectQuery, currserv);
		  currserv->sqlConnectQuery = NULL;
#endif
		;
    break;}
case 112:
#line 754 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 113:
#line 756 "./config.y"
{
		  char *np;
		  
		  for (np = yyvsp[-1].str; *np; np++)
		  {
		    if (isspace (*np & 0xFF))
		    {
		      syslog (LOG_ERR, "A user name can't contain whitespace(%s). Aliases can.", yyvsp[-1].str);
		      YYABORT;
		    }
		  }
		  if (curruser)
		  {
		    curruser = copy_user (curruser, yyvsp[-1].str, currserv);
		    if (!curruser)
		      YYABORT;
		  }
		  else
		  {
		    curruser = find_server_user (currserv, yyvsp[-1].str, currserv);
		    if (!curruser)
		    {
		      curruser = new_user (yyvsp[-1].str, currserv);
		      curruser->allowLogin = currserv->allowLogin;
		      curruser->allowSecLogin = currserv->allowSecLogin;
		      curruser->allowForeign = currserv->allowForeign;
		      curruser->allowOutOfRange = currserv->allowOutOfRange;
		    }
		    if (!curruser)
		      YYABORT;
		    pfree (curruser->access, curruser);
		    curruser->access = pattach(currserv->access, curruser);
		    curruser->defHardLink = currserv->defHardLink;
		    curruser->maxIdle = currserv->maxIdle;
		    curruser->passwordNeeded = currserv->passwordNeeded;
		    curruser->dirMsgFile = pattach (currserv->dirMsgFile, curruser);
#ifdef USE_SQL
		    curruser->sqlDirQuery = pattach (currserv->sqlDirQuery, curruser);
#endif
		    // Reset uid and gid, but don't activate in spec_flags.
		    curruser->uid = unprivUid;
		    curruser->gid = unprivGid;
		    if(currserv->chroot)
		    {
		      pfree (curruser->chroot, curruser);
		      curruser->chroot = pattach(currserv->chroot, curruser);
		      curruser->spec_flags |= ufChroot;
		    }
		  }
		  usertop = talloc (sizeof (*usertop));
		  if (!usertop)
		    YYABORT;
		  usertop->item = curruser;
		  usertop->next = userstack;
		  userstack = usertop;
		;
    break;}
case 114:
#line 815 "./config.y"
{
		  if(curruser->chroot)
		  {
		    char *tmp = curruser->chroot;
		    char *home = curruser->home;
		    user_t *pwUser = NULL;
		    
		    if (!home)
		    {
		      pwUser = find_passwd_user (curruser->name, NULL);
		      if (pwUser && pwUser->home)
			home = pwUser->home;
		    }
		    curruser->chroot = pstring(full_path(curruser->chroot,
			  NULL, home), curruser);
		    pfree(tmp, curruser);
		    pfree (pwUser, NULL);
		  }
		  curruser->next = padopt (currserv->users, currserv, curruser);
		  currserv->users = curruser;
		  userstack = userstack->next;
		  curruser = userstack? userstack->item : NULL;
		;
    break;}
case 120:
#line 850 "./config.y"
{
		  curruser->anonymous = (yyvsp[0].num != 0);
		  curruser->spec_flags |= ufAnonymous;
		  if(curruser->anonymous)
		  {
		    curruser->allowLogin = 1;
		    curruser->passwordNeeded = 1;
		  }
		;
    break;}
case 121:
#line 860 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 122:
#line 862 "./config.y"
{
		  server_add_alias(currserv, yyvsp[0].str, curruser->name);
		;
    break;}
case 123:
#line 866 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 124:
#line 868 "./config.y"
{
		  pfree(curruser->home, curruser);
		  curruser->home = pstring(full_path (yyvsp[0].str, NULL, NULL), curruser);
		  curruser->spec_flags |= ufHome;
		;
    break;}
case 125:
#line 874 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 126:
#line 876 "./config.y"
{
		  pfree(curruser->chroot, curruser);
		  curruser->chroot = pstring(yyvsp[0].str, curruser);
		  curruser->spec_flags |= ufChroot;
		;
    break;}
case 127:
#line 882 "./config.y"
{
		  curruser->passwordNeeded = (yyvsp[0].num != 0);
		;
    break;}
case 128:
#line 886 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 129:
#line 888 "./config.y"
{
		  pfree (curruser->password, curruser);
		  curruser->password = pstring(yyvsp[0].str, curruser);
		  curruser->passwordNeeded = 1;
		  curruser->anonymous = 0;
		  curruser->spec_flags |= ufPassword | ufAnonymous;
		;
    break;}
case 130:
#line 896 "./config.y"
{ confExpectingToken = D_UID; ;
    break;}
case 131:
#line 898 "./config.y"
{
		  curruser->spec_flags |= ufUid;
		  curruser->uid = yyvsp[0].num;
		;
    break;}
case 132:
#line 903 "./config.y"
{ confExpectingToken = D_GID; ;
    break;}
case 133:
#line 905 "./config.y"
{
		  curruser->spec_flags |= ufGid;
		  curruser->gid = yyvsp[0].num;
		;
    break;}
case 134:
#line 910 "./config.y"
{
		  curruser->allowLogin = (yyvsp[0].num != 0);
		;
    break;}
case 135:
#line 914 "./config.y"
{
		  curruser->allowSecLogin = (yyvsp[0].num != 0);
		;
    break;}
case 136:
#line 918 "./config.y"
{
		  curruser->allowForeign = (yyvsp[0].num != 0);
		;
    break;}
case 137:
#line 922 "./config.y"
{
		  curruser->allowOutOfRange = (yyvsp[0].num != 0);
		;
    break;}
case 138:
#line 926 "./config.y"
{
		  curruser->maxIdle = yyvsp[0].num;
		;
    break;}
case 139:
#line 930 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 140:
#line 932 "./config.y"
{
		  pfree (curruser->external_login, curruser);
		  curruser->external_login = pstring (full_path (yyvsp[0].str, NULL, curruser->home), curruser);
		;
    break;}
case 141:
#line 937 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 142:
#line 939 "./config.y"
{
		  pfree (curruser->access_program, curruser);
		  curruser->access_program = pstring (full_path (yyvsp[0].str, NULL, curruser->home), curruser);
		;
    break;}
case 143:
#line 944 "./config.y"
{
		  curruser->defHardLink = yyvsp[0].num? 1 : 0;
		;
    break;}
case 144:
#line 948 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 145:
#line 950 "./config.y"
{
		  pfree (curruser->dirMsgFile, curruser);
		  curruser->dirMsgFile = pstring (yyvsp[0].str, curruser);
		;
    break;}
case 146:
#line 955 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 147:
#line 957 "./config.y"
{
#ifdef USE_SQL
		  pfree (curruser->sqlDirQuery, curruser);
		  curruser->sqlDirQuery = pstring (yyvsp[0].str, curruser);
#endif
		;
    break;}
case 148:
#line 964 "./config.y"
{
		  curruser->adminPrivs = yyvsp[0].num;
		;
    break;}
case 149:
#line 968 "./config.y"
{
		  curruser->maxLogins = yyvsp[0].num;
		;
    break;}
case 151:
#line 975 "./config.y"
{
		  yyval.num = yyvsp[0].num;
		;
    break;}
case 152:
#line 979 "./config.y"
{
		  yyval.num = yyvsp[-2].num | yyvsp[0].num;
		;
    break;}
case 153:
#line 985 "./config.y"
{
		  yyval.num = admList;
		;
    break;}
case 154:
#line 989 "./config.y"
{
		  yyval.num = admMsg;
		;
    break;}
case 155:
#line 993 "./config.y"
{
		  yyval.num = admAbort;
		;
    break;}
case 156:
#line 997 "./config.y"
{
		  yyval.num = admDisconnect;
		;
    break;}
case 157:
#line 1001 "./config.y"
{
		  yyval.num = admReload;
		;
    break;}
case 158:
#line 1005 "./config.y"
{
		  yyval.num = -1;
		;
    break;}
case 161:
#line 1015 "./config.y"
{
		  curruser->spec_flags &= ~ufUid;
		;
    break;}
case 162:
#line 1019 "./config.y"
{
		  curruser->spec_flags &= ~ufGid;
		;
    break;}
case 163:
#line 1023 "./config.y"
{
		  curruser->spec_flags &= ~ufHome;
		  if(curruser->home)
		    pfree(curruser->home, curruser);
		  curruser->home = NULL;
		;
    break;}
case 164:
#line 1030 "./config.y"
{
		  curruser->spec_flags &= ~ufPassword;
		;
    break;}
case 165:
#line 1034 "./config.y"
{
		  pfree (curruser->external_login, curruser);
		  curruser->external_login = NULL;
		;
    break;}
case 166:
#line 1039 "./config.y"
{
		  pfree (curruser->access_program, curruser);
		  curruser->access_program = NULL;
		;
    break;}
case 167:
#line 1044 "./config.y"
{
		  pfree (curruser->dirMsgFile, curruser);
		  curruser->dirMsgFile = NULL;
		;
    break;}
case 168:
#line 1049 "./config.y"
{
#ifdef USE_SQL
		  pfree (curruser->sqlDirQuery, curruser);
		  curruser->sqlDirQuery = NULL;
#endif
		;
    break;}
case 169:
#line 1056 "./config.y"
{
		  curruser->adminPrivs = 0;
		;
    break;}
case 171:
#line 1065 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 172:
#line 1067 "./config.y"
{
		  access_t *p;
		  
		  p = currdir;
		  currdir = palloc(sizeof(access_t), NULL, NULL);
		  if(!currdir)
		    YYABORT;
		  currdir->path = pstring (full_path (yyvsp[-1].str, p? p->path : NULL,
		        curruser? curruser->home : NULL), currdir);
		  dirtop = talloc (sizeof (*dirtop));
		  if (!dirtop)
		    YYABORT;
		  dirtop->item = currdir;
		  dirtop->next = dirstack;
		  dirstack = dirtop;
		;
    break;}
case 173:
#line 1086 "./config.y"
{
		  access_t *p = NULL, *a = NULL;
		  
		  dirstack = dirstack->next;
		  if(curruser)
		  {
		    if (currdir->numMasks || !curruser->access || !curruser->access->numMasks)
		    {
		      currdir->next = padopt(curruser->access, curruser, currdir);
		      curruser->access = pattach(currdir, curruser);
		    }
		    else
		    {
		      p = curruser->access;
		      if (pnparents (p) > 1)
		      {
			a = palloc (sizeof (access_t), curruser, NULL);
			if (!a)
			  YYABORT;
			pfree (p, curruser);
			curruser->access = a;
		      }
		    }
		  }
		  else
		  {
		    if (currdir->numMasks || !currserv->access || !currserv->access->numMasks)
		    {
		      currdir->next = padopt(currserv->access, currserv, currdir);
		      currserv->access = pattach(currdir, currserv);
		    }
		    else
		    {
		      p = currserv->access;
		      if (pnparents (p) > 1)
		      {
			a = palloc (sizeof (access_t), currserv, NULL);
			if (!a)
			  YYABORT;
			pfree (p, currserv);
			currserv->access = a;
		      }
		    }
		  }
		  if (p)
		  {
		    // We need to split up the access chain down to the place
		    // where we should insert.
		    while (1)
		    {
		      if (a)
		      {
			memcpy (a, p, sizeof (*a));
			a->path = pattach (p->path, a);
			a->masks = pattach (p->masks, a);
			a->fakeUser = pattach (p->fakeUser, a);
			a->fakeGroup = pattach (p->fakeGroup, a);
			a->fakeFile = pattach (p->fakeFile, a);
			a->fakeDir = pattach (p->fakeDir, a);
			a->next = pattach (p->next, a);
			p = a;
		      }
		      if (!p->next || !p->next->numMasks)
			break;
		      if (a)
		      {
			a = palloc (sizeof (access_t), p, NULL);
			if (!a)
			  YYABORT;
			p = p->next;
			pfree (p->next, p);
			p->next = a;
		      }
		      else
			p = p->next;
		    }
		    currdir->next = padopt (p->next, p, currdir);
		    p->next = pattach (currdir, p);
		  }
		  currdir = dirstack? dirstack->item : NULL;
		;
    break;}
case 178:
#line 1178 "./config.y"
{
		  currdir->deny &= ~yyvsp[0].num;
		  currdir->require &= ~yyvsp[0].num;
		  currdir->allow |= yyvsp[0].num;
		;
    break;}
case 179:
#line 1184 "./config.y"
{
		  currdir->allow &= ~yyvsp[0].num;
		  currdir->require &= ~yyvsp[0].num;
		  currdir->deny |= yyvsp[0].num;
		;
    break;}
case 180:
#line 1190 "./config.y"
{
		  yyvsp[0].num &= acEncrypted | acSigned;
		  
		  currdir->allow &= ~yyvsp[0].num;
		  currdir->deny &= ~yyvsp[0].num;
		  currdir->require |= yyvsp[0].num;
		;
    break;}
case 181:
#line 1198 "./config.y"
{
		  currdir->hidden = (yyvsp[0].num != 0);
		;
    break;}
case 182:
#line 1202 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 183:
#line 1204 "./config.y"
{
		  pfree(currdir->fakeUser, currdir);
		  currdir->fakeUser = pstring(yyvsp[0].str, currdir);
		;
    break;}
case 184:
#line 1209 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 185:
#line 1211 "./config.y"
{
		  pfree(currdir->fakeGroup, currdir);
		  currdir->fakeGroup = pstring(yyvsp[0].str, currdir);
		;
    break;}
case 186:
#line 1216 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 187:
#line 1218 "./config.y"
{
		  pfree(currdir->fakeFile, currdir);
		  currdir->fakeFile = pstring(yyvsp[0].str, currdir);
		;
    break;}
case 188:
#line 1223 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 189:
#line 1225 "./config.y"
{
		  pfree(currdir->fakeDir, currdir);
		  currdir->fakeDir = pstring(yyvsp[0].str, currdir);
		;
    break;}
case 190:
#line 1230 "./config.y"
{
		  currdir->hardlink = yyvsp[0].num? 1 : -1;
		;
    break;}
case 191:
#line 1234 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 192:
#line 1236 "./config.y"
{
		  pfree (currdir->dirMsgFile, currdir);
		  currdir->dirMsgFile = pstring (yyvsp[0].str, currdir);
		;
    break;}
case 193:
#line 1241 "./config.y"
{ confExpectingToken = D_STRING; ;
    break;}
case 194:
#line 1243 "./config.y"
{
		  if (currdir->numMasks)
		    currdir->masks = prealloc (currdir->masks, sizeof (*currdir->masks) * (currdir->numMasks + 1));
		  else
		    currdir->masks = palloc (sizeof (*currdir->masks), currdir, NULL);
		  if (!currdir->masks)
		    YYABORT;
		  currdir->masks[currdir->numMasks++] = pstring (yyvsp[0].str, currdir->masks);
		;
    break;}
case 198:
#line 1260 "./config.y"
{
		  if(currdir->fakeUser != (char*)-1)
		    pfree(currdir->fakeUser, currdir);
		  currdir->fakeUser = (char*)-1;
		;
    break;}
case 199:
#line 1266 "./config.y"
{
		  if(currdir->fakeGroup != (char*)-1)
		    pfree(currdir->fakeGroup, currdir);
		  currdir->fakeGroup = (char*)-1;
		;
    break;}
case 200:
#line 1272 "./config.y"
{
		  if(currdir->fakeFile != (char*)-1)
		    pfree(currdir->fakeFile, currdir);
		  currdir->fakeFile = (char*)-1;
		;
    break;}
case 201:
#line 1278 "./config.y"
{
		  if(currdir->fakeDir != (char*)-1)
		    pfree(currdir->fakeDir, currdir);
		  currdir->fakeDir = (char*)-1;
		;
    break;}
case 202:
#line 1284 "./config.y"
{
		  pfree (currdir->dirMsgFile, currdir);
		  currdir->dirMsgFile = NULL;
		;
    break;}
case 203:
#line 1291 "./config.y"
{
		  yyval.num = yyvsp[0].num;
		;
    break;}
case 204:
#line 1295 "./config.y"
{
		  yyval.num = yyvsp[-2].num | yyvsp[0].num;
		;
    break;}
case 205:
#line 1301 "./config.y"
{
		  yyval.num = acSearch;
		;
    break;}
case 206:
#line 1305 "./config.y"
{
		  yyval.num = acReadFile;
		;
    break;}
case 207:
#line 1309 "./config.y"
{
		  yyval.num = acListing;
		;
    break;}
case 208:
#line 1313 "./config.y"
{
		  yyval.num = acCreateFile;
		;
    break;}
case 209:
#line 1317 "./config.y"
{
		  yyval.num = acCreateDir;
		;
    break;}
case 210:
#line 1321 "./config.y"
{
		  yyval.num = acAppend;
		;
    break;}
case 211:
#line 1325 "./config.y"
{
		  yyval.num = acOverwrite;
		;
    break;}
case 212:
#line 1329 "./config.y"
{
		  yyval.num = acDelete;
		;
    break;}
case 213:
#line 1333 "./config.y"
{
		  yyval.num = acRename;
		;
    break;}
case 214:
#line 1337 "./config.y"
{
		  yyval.num = acEncrypted;
		;
    break;}
case 215:
#line 1341 "./config.y"
{
		  yyval.num = acSigned;
		;
    break;}
case 216:
#line 1345 "./config.y"
{
		  yyval.num = acSearch | acReadFile | acListing;
		;
    break;}
case 217:
#line 1349 "./config.y"
{
		  yyval.num = acCreateFile | acCreateDir | acAppend | acOverwrite |
		        acDelete;
		;
    break;}
case 218:
#line 1354 "./config.y"
{
		  yyval.num = acCreateFile | acCreateDir | acAppend;
		;
    break;}
case 219:
#line 1358 "./config.y"
{
		  yyval.num = -1;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1363 "./config.y"

